package de.accso.flexinale.ticketing.domain.model;

import de.accso.flexinale.common.shared_kernel.*;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

public class Ticket implements Identifiable, Versionable, EqualsByContent {
    public record Gueltig(Boolean raw) implements RawWrapper<Boolean> {}

    public enum VerkaufsKanal {
        ONLINE,
        ZENTRAL,
        KINOKASSE
    }

    public final Id id;
    public final Version version;
    
    public final Id filmId;
    public final Id vorfuehrungId;
    public final Id besucherId;
    @DoNotCheckInArchitectureTests
    public VerkaufsKanal verkaufsKanal;
    public Gueltig gueltig;

    public Ticket(final Id id,
                  final Id filmId, final Id vorfuehrungId, final Id besucherId,
                  final VerkaufsKanal verkaufsKanal){
        this(id, filmId, vorfuehrungId, besucherId,  verkaufsKanal, new Gueltig(true));
    }

    public Ticket(final Id id,
                  final Id filmId, final Id vorfuehrungId, final Id besucherId,
                  final VerkaufsKanal verkaufsKanal, final Gueltig gueltig) {
        this(id, Versionable.unknownVersion(), filmId, vorfuehrungId, besucherId,  verkaufsKanal, gueltig);
    }

    public Ticket(final Id id, final Version version,
                  final Id filmId, final Id vorfuehrungId, final Id besucherId,
                  final VerkaufsKanal verkaufsKanal, final Gueltig gueltig) {
        this.id = id;
        this.version = version;
        this.filmId = filmId;
        this.vorfuehrungId = vorfuehrungId;
        this.besucherId = besucherId;
        this.verkaufsKanal = verkaufsKanal;
        this.gueltig = gueltig;
    }

    @Override
    public Id id() {
        return id;
    }

    @Override
    public Version version() {
        return version;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (!equalsByContent(o)) return false;

        if (this == o) {return true;}
        if (o == null || getClass() != o.getClass()) {return false;}
        Ticket that = (Ticket) o;
        return new EqualsBuilder().append(version, that.version).isEquals();
    }

    @Override
    public boolean equalsByContent(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        Ticket that = (Ticket) o;

        return new EqualsBuilder()
                .append(id, that.id)
                .append(filmId, that.filmId)
                .append(vorfuehrungId, that.vorfuehrungId)
                .append(besucherId, that.besucherId)
                .append(verkaufsKanal, that.verkaufsKanal)
                .append(gueltig, that.gueltig)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id).append(version)
                .append(filmId).append(vorfuehrungId).append(besucherId)
                .append(verkaufsKanal)
                .append(gueltig)
                .toHashCode();
    }
}
